// DnsContentHandler.java
//
// gestionnaire de contenu pour le protocole DNS

package up13.dns;
import java.net.*;
import java.io.*;

public class DnsContentHandler extends ContentHandler {

	String queryValue="";
	String resultValue="";

	public Object getContent(URLConnection urlc) throws IOException {
		URL url = urlc.getURL();
		String requete = url.getQuery();
		if (requete == null || requete.equals("HtoIP")) {requestHtoIP(url);};		
		if (requete != null && requete.equals("IPtoH")) {requestIPtoH(url);};		
		if (requete != null && requete.equals("MX")) {requestDtoMX(url);};
		return new DnsEntry(requete,queryValue,resultValue);
	}

	private void requestHtoIP(URL url) throws IOException {
		String command = new String();
		queryValue = url.getHost();
		command = "dig +short "+queryValue;
		Process p = Runtime.getRuntime().exec(command);
		resultValue="";
		InputStream in = p.getInputStream();
		int b;
		while ((b = in.read()) != -1 && !Character.isDigit((char) b));
		if (b != -1) {
			resultValue += (char) b;
			while ((b = in.read()) != -1 && ((char) b) != '\n') resultValue += (char) b;
		};
		in.close();	
	}

	private void requestIPtoH(URL url) throws IOException {
		String command = new String();
		queryValue = url.getHost();
		command = "dig +short -x "+queryValue;
		Process p = Runtime.getRuntime().exec(command);
		resultValue="";
		InputStream in = p.getInputStream();
		int b;
		while ((b = in.read()) != -1) resultValue += (char) b;
		in.close();
		if (resultValue.length() > 2) resultValue = resultValue.substring(0,resultValue.length()-2);
	}

	private void requestDtoMX(URL url) throws IOException {
		String command = new String();
		queryValue = url.getHost();
		command = "dig +short -t MX "+queryValue;
		Process p = Runtime.getRuntime().exec(command);
		resultValue="";
		InputStream in = p.getInputStream();
		int b;
		while ((b = in.read()) != -1 && !Character.isLetter((char) b));
		if (b != -1) {
			resultValue += (char) b;
			while ((b = in.read()) != -1) resultValue += (char) b;
		};
		in.close();
		if (resultValue.length() > 2) resultValue = resultValue.substring(0,resultValue.length()-2);
	}

}
